#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Javascript library in a notebook: cytoscape.js
# 
# Tries [cytoscape.js](http://js.cytoscape.org/) in a notebook. The example is taken from the gallery and more specifically the following one [cyjsSimpleDemoWithMagic.ipynb](https://github.com/paul-shannon/cyjs-jupyter/blob/master/self-contained-notebooks/javascriptOnly/cyjsSimpleDemoWithMagic.ipynb). A kind of tutorial is available at [Getting started with Cytoscape.js](http://blog.js.cytoscape.org/2016/05/24/getting-started/).

# In[1]:


from jyquickhelper import RenderJS
css = None
libs = [dict(path='http://www.xavierdupre.fr/js/cytoscape/cytoscape.min.js', name='cytoscape')]
script = """
    
    var cy = cytoscape({
      container: document.getElementById('__ID__'),
      elements: {
         nodes: [
           {data: {id: 'a', name: 'Node A', type: 'big' }},
           {data: {id: 'b', name: 'Node B', type: 'little'}},
           ],
        edges: [
           {data: {source: 'a', target: 'b'}},
           {data: {source: 'b', target: 'a'}}
           ]
        },
  
     style: [
        {selector: 'node',
           style: {
              'text-valign': 'center',
              'text-halign': 'center',
              'border-color': 'red',
              'background-color': 'white',
              'border-width': 1,
              'label': 'data(name)',
              'height': 100,  // defaults
              'width': 100
              }},
        {selector: "node[type='big']",
          style: {
             'height': 150,
             'width': 150,
             'shape': 'roundrectangle'
             }},
        {selector: "node[type='little']",
          style: {
             'height': 50,
             'width': 80
             }},
        {selector: 'edge',
           style: {
             'width': '1px',
             'line-color': 'blue',
             'target-arrow-shape': 'triangle',
             'target-arrow-color': 'black',
             'curve-style': 'bezier'
             }}
         ],
              
     ready: function(){
        console.log("small cyjs network ready");
        } // ready
       }); // cytoscape
"""
jr = RenderJS(script, css=css, libs=libs, height='200px', width='500px')
jr


# In[2]:


print(jr._repr_html_())


# In[3]: